diff -Naur test-for-latech/net/qsocket/utils.h testqf-for-latech/net/qsocket/utils.h
--- test-for-latech/net/qsocket/utils.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/net/qsocket/utils.h	2004-06-11 07:48:02.000000000 -0400
@@ -0,0 +1,69 @@
+static __inline__ int socket_hash(u32 handle)
+{
+  return handle&0xFF;
+}
+
+
+static __inline__ struct socket *socki_lookup(struct inode *inode)
+{
+	return &inode->u.socket_i;
+}
+
+/**
+ *	sockfd_lookup	- 	Go from a file number to its socket slot
+ *	@fd: file handle
+ *	@err: pointer to an error code return
+ *
+ *	The file handle passed in is locked and the socket it is bound
+ *	too is returned. If an error occurs the err pointer is overwritten
+ *	with a negative errno code and NULL is returned. The function checks
+ *	for both invalid handles and passing a handle which is not a socket.
+ *
+ *	On a success the socket object pointer is returned.
+ */
+
+static struct socket *sockfd_lookup(int fd, int *err)
+{
+	struct file *file;
+	struct inode *inode;
+	struct socket *sock;
+
+	if (!(file = fget(fd)))
+	{
+		*err = -EBADF;
+		return NULL;
+	}
+
+	inode = file->f_dentry->d_inode;
+	if (!inode->i_sock || !(sock = socki_lookup(inode)))
+	{
+		*err = -ENOTSOCK;
+		fput(file);
+		return NULL;
+	}
+
+	if (sock->file != file) {
+		printk(KERN_ERR "socki_lookup: socket file changed!\n");
+		sock->file = file;
+	}
+	return sock;
+}
+
+static  __inline__ void sockfd_put(struct socket *sock)
+{
+	fput(sock->file);
+}
+
+
+static __inline__ unsigned dwcs_hash(u32 h)
+{
+    h ^= h>>8;
+    h ^= h>>4;
+    return h&0xF;
+}
+
+static inline int create_socket(unsigned long *args)
+{
+      return socketcall(SYS_SOCKET, args);
+}
+
diff -Naur test-for-latech/net/sched/cls_api.c testqf-for-latech/net/sched/cls_api.c
--- test-for-latech/net/sched/cls_api.c	2004-06-11 07:40:56.000000000 -0400
+++ testqf-for-latech/net/sched/cls_api.c	2004-06-11 07:48:00.000000000 -0400
@@ -42,6 +42,21 @@
 /* Protects list of registered TC modules. It is pure SMP lock. */
 static rwlock_t cls_mod_lock = RW_LOCK_UNLOCKED;
 
+struct tcf_proto_ops * tcf_proto_lookup_ops_string(const char *kind)
+{
+	struct tcf_proto_ops *t = NULL;
+
+	if (kind) {
+		read_lock(&cls_mod_lock);
+		for (t = tcf_proto_base; t; t = t->next) {
+			if (strcmp(kind, t->kind) == 0)
+				break;
+		}
+		read_unlock(&cls_mod_lock);
+	}
+	return t;
+}
+
 /* Find classifier type by string name */
 
 struct tcf_proto_ops * tcf_proto_lookup_ops(struct rtattr *kind)
@@ -448,6 +463,10 @@
           register_tcf_proto_ops(&cls_##name##_ops); \
 	}
 
+#ifdef CONFIG_NET_CLS_SOCKET
+	INIT_TC_FILTER(socket);
+#endif
+
 #ifdef CONFIG_NET_CLS_U32
 	INIT_TC_FILTER(u32);
 #endif
diff -Naur test-for-latech/net/sched/cls_socket.c testqf-for-latech/net/sched/cls_socket.c
--- test-for-latech/net/sched/cls_socket.c	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/net/sched/cls_socket.c	2004-06-11 07:48:00.000000000 -0400
@@ -0,0 +1,544 @@
+/*
+ * net/sched/cls_socket.c	Classifier mapping of open sockets to traffic class.
+ *
+ *		This program is free software; you can redistribute it and/or
+ *		modify it under the terms of the GNU General Public License
+ *		as published by the Free Software Foundation; either version
+ *		2 of the License, or (at your option) any later version.
+ *
+ * Authors:	Gregory Losik, <gregory.losik@gtri.gatech.edu>
+ *              This clasifier is similar to other provided classifiers, but 
+ *              is implemented for the different use purposes.  One can 
+ *              use it to classify packets based on the packets associated 
+ *              PID and FD, or simply by provided INODE number. 
+ *
+ * Changes:
+ *
+ */
+
+#include <linux/config.h>
+#include <linux/module.h>
+#include <asm/uaccess.h>
+#include <asm/system.h>
+#include <asm/bitops.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/string.h>
+#include <linux/mm.h>
+#include <linux/socket.h>
+#include <linux/sockios.h>
+#include <linux/in.h>
+#include <linux/errno.h>
+#include <linux/interrupt.h>
+#include <linux/if_ether.h>
+#include <linux/inet.h>
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/notifier.h>
+#include <net/ip.h>
+#include <net/route.h>
+#include <linux/skbuff.h>
+#include <net/sock.h>
+#include <net/pkt_sched.h>
+
+#include <linux/fs.h>                   /* for inode struct */
+#include <linux/net.h>                  /* for socket struct */
+#include <linux/file.h>                 /* for fcheck_task() */
+#include <linux/qsocket.h>
+
+/*
+struct socket_head
+{
+  struct socket_filter *ht[256];       
+};
+
+
+struct socket_filter
+{
+  struct socket_filter	*next;
+  u32			id;
+  u32                   pid;          
+  unsigned long         fd;           
+  unsigned long         i_ino;       
+  struct tcf_result	res;
+#ifdef CONFIG_NET_CLS_POLICE
+  struct tcf_police	*police;
+#endif
+};
+*/
+
+/* 
+ * The hash table for storing socket_filter structures in socket_head->ht 
+ */
+static __inline__ int socket_hash(u32 handle)
+{
+  return handle&0xFF;
+}
+
+
+
+/*
+ * Used to match a packet to a class based on certain properties of 
+ * the packet.  Socket filter determines the inode from which the
+ * packet was sent, and then compares this inode number to filter's
+ * inode # that it monitors for.
+ */
+static int socket_classify(struct sk_buff *skb, struct tcf_proto *tp,
+			  struct tcf_result *res)
+{
+	struct socket_head *head = (struct socket_head*)tp->root;
+	struct socket_filter *f = NULL;
+	unsigned long i_ino = 0;
+#ifdef CONFIG_IP_FIREWALL
+	u32 id = skb->fwmark;
+#else
+	u32 id = 0;
+#endif
+
+	{
+	  /* we try to get the inode, given the pointer to sk_buff */
+	  struct sock *sk = NULL;
+	  struct socket *sket = NULL;
+	  struct inode *node = NULL;
+	  
+	  if (skb && (sk=skb->sk) && (sket=sk->socket) && (node=sket->inode) && node )
+	    i_ino = node->i_ino;
+	}
+
+	/* tying to access socket_filter structure(s) of a current filter, and 
+	 * determine if it matches inode number */
+	if (head == NULL)
+	  goto old_method;
+
+
+
+	
+	for (f=head->ht[socket_hash(id)]; f; f=f->next) {
+	  if (f->i_ino == i_ino) {
+	    *res = f->res;
+#ifdef CONFIG_NET_CLS_POLICE
+	    if (f->police)
+	      return tcf_police(skb, f->police);
+#endif
+//	    printk(KERN_INFO __FUNCTION__ "classified successfully to classid = %d\n", res->classid);
+	    
+	    return 0;
+	  }
+	}
+	return -1;
+
+old_method:
+	/*
+	if (id && (TC_H_MAJ(id) == 0 ||
+		     !(TC_H_MAJ(id^tp->q->handle)))) {
+		res->classid = id;
+		res->class = 0;
+		return 0;
+	}
+	*/
+	return -1;
+}
+
+
+
+
+/*
+ * Returns the internal ID corresponding to the handle.  The internal
+ * id is the address of the socket_filter structure.
+ */
+static unsigned long socket_get(struct tcf_proto *tp, u32 handle)
+{
+	struct socket_head *head = (struct socket_head*)tp->root;
+	struct socket_filter *f;
+
+	if (head == NULL) {
+	  return 0;
+	}
+
+	for (f=head->ht[socket_hash(handle)]; f; f=f->next) {
+	         if (f->id == handle) {
+			return (unsigned long)f;
+		 }
+	}
+
+	return 0;
+}
+
+
+/*
+ * The put function on a filter is used to de-reference a filter that was 
+ * previouslly referenced using the get function.  In our case, we don't 
+ * keep track of references and therefore can ignore this function.
+ */
+static void socket_put(struct tcf_proto *tp, unsigned long f)
+{
+}
+
+
+/*
+ * The init function on a filter is used to initialize the parameters for 
+ * a filter.
+ */
+static int socket_init(struct tcf_proto *tp)
+{
+  MOD_INC_USE_COUNT;
+ return 0;
+}
+
+
+/*
+ * The destory function on a filter is used to remove a filter.  We 
+ * find the filter structure and then if the filter was bounded to 
+ * a class, we unbind it, so that class knows about it.  Finally we
+ * free the memory allocated by the filter stucture.
+ */
+static void socket_destroy(struct tcf_proto *tp)
+{
+	struct socket_head *head = (struct socket_head*)xchg(&tp->root, NULL);
+	struct socket_filter *f;
+	int h;
+
+	if (head == NULL) {
+		MOD_DEC_USE_COUNT;
+		return;
+	}
+
+	for (h=0; h<256; h++) {
+		while ((f=head->ht[h]) != NULL) {
+			unsigned long cl;
+			head->ht[h] = f->next;
+
+			if ((cl = __cls_set_class(&f->res.class, 0)) != 0)
+				tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
+#ifdef CONFIG_NET_CLS_POLICE
+			tcf_police_release(f->police);
+#endif
+			kfree(f);
+		}
+	}
+	kfree(head);
+	MOD_DEC_USE_COUNT;
+}
+
+
+
+/*
+ * The delete function on a filter is used to delete a particular element of the 
+ * filter.  Similar to destroy() we call unbind on a class.
+ */
+static int socket_delete(struct tcf_proto *tp, unsigned long arg)
+{
+	struct socket_head *head = (struct socket_head*)tp->root;
+	struct socket_filter *f = (struct socket_filter*)arg;
+	struct socket_filter **fp;
+
+	if (head == NULL || f == NULL)
+		return -EINVAL;
+
+	for (fp=&head->ht[socket_hash(f->id)]; *fp; fp = &(*fp)->next) {
+		if (*fp == f) {
+			unsigned long cl;
+
+			*fp = f->next;
+			//synchronize_bh();
+
+			if ((cl = __cls_set_class(&f->res.class, 0)) != 0)
+				tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
+#ifdef CONFIG_NET_CLS_POLICE
+			tcf_police_release(f->police);
+#endif
+			kfree(f);
+			return 0;
+		}
+	}
+	return -EINVAL;
+}
+
+
+
+
+/*
+ * The change function on a filter is used to change the properties 
+ * of a filter. This is similar to the change function on classes and 
+ * queuing disciplines.
+ */
+static int socket_change(struct tcf_proto *tp, unsigned long base,
+		     u32 handle,
+		     struct rtattr **tca,
+		     unsigned long *arg)
+{
+	struct socket_head *head = (struct socket_head*)tp->root;
+	struct socket_filter *f;
+	struct rtattr *opt = tca[TCA_OPTIONS-1];
+	struct rtattr *tb[TCA_SOCKET_MAX];
+	int    err;
+
+	if (!opt)
+		return handle ? -EINVAL : 0;
+
+	if (rtattr_parse(tb, TCA_SOCKET_MAX, RTA_DATA(opt), RTA_PAYLOAD(opt)) < 0)
+		return -EINVAL;
+
+
+	if ((f = (struct socket_filter*)*arg) != NULL) {
+		/* Node exists: adjust only classid */
+
+		if (f->id != handle && handle)
+		  return -EINVAL;
+		if (tb[TCA_SOCKET_CLASSID-1]) {
+		  unsigned long cl;
+
+		  f->res.classid = *(u32*)RTA_DATA(tb[TCA_SOCKET_CLASSID-1]);
+		  cl = tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid);
+		  cl = __cls_set_class(&f->res.class, cl);
+		  if (cl)
+		    tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
+		}
+
+		if (tb[TCA_SOCKET_PROCESSID-1]) {
+		  err = -EINVAL;
+		  if (RTA_PAYLOAD(tb[TCA_SOCKET_PROCESSID-1]) != 4)
+		    goto errout;
+		f->pid = *(u32*)RTA_DATA(tb[TCA_SOCKET_PROCESSID-1]);
+		}
+
+		if (tb[TCA_SOCKET_FDID-1]) {
+		  err = -EINVAL;
+		  if (RTA_PAYLOAD(tb[TCA_SOCKET_FDID-1]) != 4)
+		    goto errout;
+		  f->fd = *(u32*)RTA_DATA(tb[TCA_SOCKET_FDID-1]);
+		}
+
+		if (tb[TCA_SOCKET_INODEID-1]) {
+		  err = -EINVAL;
+		  if (RTA_PAYLOAD(tb[TCA_SOCKET_INODEID-1]) != 4)
+		    goto errout;
+		  f->i_ino = *(unsigned long*)RTA_DATA(tb[TCA_SOCKET_INODEID-1]);
+		}
+
+
+#ifdef CONFIG_NET_CLS_POLICE
+		if (tb[TCA_SOCKET_POLICE-1]) {
+		  struct tcf_police *police = tcf_police_locate(tb[TCA_SOCKET_POLICE-1], tca[TCA_RATE-1]);
+		  
+		  police = xchg(&f->police, police);
+		  //synchronize_bh();
+		  
+		  tcf_police_release(police);
+		}
+#endif
+		return 0;
+	}
+
+
+	if (!handle)
+		return -EINVAL;
+
+	if (head == NULL) {
+		head = kmalloc(sizeof(struct socket_head), GFP_KERNEL);
+		if (head == NULL)
+			return -ENOBUFS;
+		memset(head, 0, sizeof(*head));
+
+		tp->root = head;
+		//synchronize_bh();
+	}
+
+	f = kmalloc(sizeof(struct socket_filter), GFP_KERNEL);
+	if (f == NULL)
+		return -ENOBUFS;
+	memset(f, 0, sizeof(*f));
+
+	f->id = handle;
+
+	if (tb[TCA_SOCKET_CLASSID-1]) {
+		err = -EINVAL;
+		if (RTA_PAYLOAD(tb[TCA_SOCKET_CLASSID-1]) != 4)
+			goto errout;
+		f->res.classid = *(u32*)RTA_DATA(tb[TCA_SOCKET_CLASSID-1]);
+		__cls_set_class(&f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
+	}
+
+	if (tb[TCA_SOCKET_PROCESSID-1]) {
+		err = -EINVAL;
+		if (RTA_PAYLOAD(tb[TCA_SOCKET_PROCESSID-1]) != 4)
+		      goto errout;
+		f->pid = *(u32*)RTA_DATA(tb[TCA_SOCKET_PROCESSID-1]);
+	}
+
+	if (tb[TCA_SOCKET_FDID-1]) {
+	  err = -EINVAL;
+	  if (RTA_PAYLOAD(tb[TCA_SOCKET_FDID-1]) != 4)
+	    goto errout;
+	  f->fd = *(u32*)RTA_DATA(tb[TCA_SOCKET_FDID-1]);
+	}
+
+	if (tb[TCA_SOCKET_INODEID-1]) {
+	  err = -EINVAL;
+	  if (RTA_PAYLOAD(tb[TCA_SOCKET_INODEID-1]) != 4)
+	    goto errout;
+	  f->i_ino = *(unsigned long*)RTA_DATA(tb[TCA_SOCKET_INODEID-1]);
+	}
+
+#ifdef CONFIG_NET_CLS_POLICE
+	if (tb[TCA_SOCKET_POLICE-1])
+		f->police = tcf_police_locate(tb[TCA_SOCKET_POLICE-1], tca[TCA_RATE-1]);
+#endif
+
+
+	/* Determine inode by having pid and fd */
+
+	read_lock(&tasklist_lock);
+	if( !f->i_ino && f->pid ) {
+	  struct task_struct *ts = find_task_by_pid( f->pid );
+	  struct file *fl = NULL;
+
+	  if ( ts  && (fl=fcheck_files(ts->files,f->fd) ) ) {
+	    if ( fl->f_dentry && fl->f_dentry->d_inode ) {
+	      f->i_ino = fl->f_dentry->d_inode->i_ino;
+	    }
+	  }
+	}
+	read_unlock(&tasklist_lock);
+
+	f->next = head->ht[socket_hash(handle)];
+	wmb();
+	head->ht[socket_hash(handle)] = f;
+
+	*arg = (unsigned long)f;
+	return 0;
+
+errout:
+	if (f)
+		kfree(f);
+	return err;
+}
+
+
+
+/*
+ * The walk function on a filter is used to iterate over all the elments of a 
+ * filter and invoke a callback function for each of the elements.  This is 
+ * usually used to obtain diagnostic data for all the elements of a filter.
+ */
+static void socket_walk(struct tcf_proto *tp, struct tcf_walker *arg)
+{
+	struct socket_head *head = (struct socket_head*)tp->root;
+	int h;
+
+	if (head == NULL)
+		arg->stop = 1;
+
+	if (arg->stop)
+		return;
+
+	for (h = 0; h < 256; h++) {
+		struct socket_filter *f;
+
+		for (f = head->ht[h]; f; f = f->next) {
+			if (arg->count < arg->skip) {
+				arg->count++;
+				continue;
+			}
+			if (arg->fn(tp, (unsigned long)f, arg) < 0) {
+				arg->stop = 1;
+				break;
+			}
+			arg->count++;
+		}
+	}
+}
+
+
+
+/*
+ * The dump function on a class is used to dump diagnostic data about 
+ * the filter and one or more of its elements.
+ */
+#ifdef CONFIG_RTNETLINK
+static int socket_dump(struct tcf_proto *tp, unsigned long fh,
+		   struct sk_buff *skb, struct tcmsg *t)
+{
+	struct socket_filter *f = (struct socket_filter*)fh;
+	unsigned char	 *b = skb->tail;
+	struct rtattr *rta;
+
+
+	if (f == NULL)
+		return skb->len;
+
+
+	t->tcm_handle = f->id;
+
+       if (!f->res.classid
+#ifdef CONFIG_NET_CLS_POLICE
+           && !f->police
+#endif
+           )
+		return skb->len;
+
+	rta = (struct rtattr*)b;
+	RTA_PUT(skb, TCA_OPTIONS, 0, NULL);
+
+	if (f->res.classid)
+		RTA_PUT(skb, TCA_SOCKET_CLASSID, 4, &f->res.classid);
+#ifdef CONFIG_NET_CLS_POLICE
+	if (f->police) {
+		struct rtattr * p_rta = (struct rtattr*)skb->tail;
+
+		RTA_PUT(skb, TCA_SOCKET_POLICE, 0, NULL);
+
+		if (tcf_police_dump(skb, f->police) < 0)
+			goto rtattr_failure;
+
+		p_rta->rta_len = skb->tail - (u8*)p_rta;
+	}
+#endif
+
+	rta->rta_len = skb->tail - b;
+#ifdef CONFIG_NET_CLS_POLICE
+	if (f->police) {
+		RTA_PUT(skb, TCA_STATS, sizeof(struct tc_stats), &f->police->stats);
+	}
+#endif
+	return skb->len;
+
+rtattr_failure:
+	skb_trim(skb, b - skb->data);
+	return -1;
+}
+#endif
+
+
+
+struct tcf_proto_ops cls_socket_ops = {
+	NULL,
+	"socket",
+	socket_classify,
+	socket_init,
+	socket_destroy,
+
+	socket_get,
+	socket_put,
+	socket_change,
+	socket_delete,
+	socket_walk,
+#ifdef CONFIG_RTNETLINK
+	socket_dump
+#else
+	NULL
+#endif
+};
+
+#ifdef MODULE
+int init_module(void)
+{
+	return register_tcf_proto_ops(&cls_socket_ops);
+}
+
+void cleanup_module(void) 
+{
+	unregister_tcf_proto_ops(&cls_socket_ops);
+}
+#endif
diff -Naur test-for-latech/net/sched/Config.in testqf-for-latech/net/sched/Config.in
--- test-for-latech/net/sched/Config.in	2004-06-11 07:40:56.000000000 -0400
+++ testqf-for-latech/net/sched/Config.in	2004-06-11 07:48:00.000000000 -0400
@@ -1,6 +1,7 @@
 #
 # Traffic control configuration.
-# 
+#
+tristate '  DWCS packet scheduler' CONFIG_NET_SCH_DWCS 
 tristate '  CBQ packet scheduler' CONFIG_NET_SCH_CBQ
 tristate '  CSZ packet scheduler' CONFIG_NET_SCH_CSZ
 #tristate '  H-PFQ packet scheduler' CONFIG_NET_SCH_HPFQ
@@ -24,6 +25,7 @@
 fi
 bool '  Packet classifier API' CONFIG_NET_CLS
 if [ "$CONFIG_NET_CLS" = "y" ]; then
+   bool '    Socket classifier' CONFIG_NET_CLS_SOCKET
    tristate '    TC index classifier' CONFIG_NET_CLS_TCINDEX
    tristate '    Routing table based classifier' CONFIG_NET_CLS_ROUTE4
    if [ "$CONFIG_NET_CLS_ROUTE4" != "n" ]; then
diff -Naur test-for-latech/net/sched/heap.c testqf-for-latech/net/sched/heap.c
--- test-for-latech/net/sched/heap.c	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/net/sched/heap.c	2004-06-11 07:48:00.000000000 -0400
@@ -0,0 +1,286 @@
+/*********************************************/
+/* Project:      Packet Scheduler            */
+/* File:         heap.c                      */
+/* Date:         10/17/1998                  */ 
+/* Author:       cp (chris@cc.gatech.edu)    */
+/* Contents:     heap functions              */
+
+/* Changes:
+ * J.D. Hollis, <jdhollis@cc.gatech.edu>
+ * updated HCompare() to newest version of DWCS 
+ * algorithm
+ */
+
+#include <linux/sch_dwcs.h>
+
+#define FLOOR(x)	(int)(x)
+
+/* Return parent element of i in heap array. */
+int HParent(int i) {
+
+  return (FLOOR(i/2));
+}
+
+/* Return left child element. */
+int HLeft(int i) {
+ 
+  return (2*i);
+}
+
+/* Return right child element. */
+int HRight(int i) {
+  
+  return (2*i+1);
+}
+
+/* Reorder heap. */
+void HHeapify(struct dl_heap heap[], int i, int size) {
+
+  int l, r;
+  int smallest;
+  struct dl_heap tmp;
+
+  l = HLeft(i);
+  r = HRight(i);
+ 
+  if ((l <= size) && (heap[l-1].deadline < heap[i-1].deadline))
+    smallest = l;
+  else
+    smallest = i;
+  
+  if ((r <= size) && (heap[r-1].deadline < heap[smallest-1].deadline))
+    smallest = r;
+
+  if (smallest != i) {
+    tmp = heap[i-1];
+    heap[i-1] = heap[smallest-1];
+    heap[smallest-1] = tmp;     
+    HHeapify(heap, smallest, size);
+  }
+}
+
+/* Insert element into heap. */
+void HInsert(struct dl_heap heap[], int stream, int value, int size) {
+  
+  int i = size;
+
+  while ((i > 1) && (heap[HParent(i)-1].deadline > value)) {
+    heap[i-1] = heap[HParent(i)-1];
+    i = HParent(i);
+  }  
+  heap[i-1].deadline = value;
+  heap[i-1].stream = stream;
+}
+
+/* Remove first element and reorders heap. */
+void HExtractMin(struct dl_heap heap[], int size) {
+
+  heap[0] = heap[size];   
+  heap[size].deadline = 0;   
+  heap[size].stream = 0; 
+  HHeapify(heap, 1, size);  
+}
+
+/* Remove element from heap. */
+void HDelete(struct dl_heap heap[], int stream, int size) {
+
+  int i=1;
+
+  while ((i < size+1) && (heap[i-1].stream != stream)) 
+    i++;
+  if (heap[i-1].stream == stream) {  
+    heap[i-1] = heap[size];   
+    heap[size].deadline = 0;   
+    heap[size].stream = 0; 
+    HHeapify(heap, i, size); 
+  } 
+}
+
+/*************************************************/
+/* Heap functions for loss-tolerance sorted heap */
+
+/* Compare two elements in the heap structure. */
+
+/* JDH: ok, cleaned up this function so that's it a little more readable
+ * and updated the ordering to fit the new DWCS algorithm:
+ * - earliest deadline first
+ * - equal deadlines, order lowest window-constraint first
+ * - equal deadlines and zero window-constraints, order highest window-
+ *   denominator first
+ * - equal deadlines and equal non-zero window-constraints, order lowest
+ *   window numerator first
+ * - all other cases: first-come-first-serve
+ */
+int HCompare(struct lt_heap heap1, struct lt_heap heap2) {
+
+  if (heap1.deadline > heap2.deadline)
+    return TRUE;
+  else if (heap1.deadline == heap2.deadline) {
+    if (heap1.clt > heap2.clt)
+      return TRUE;
+    else if (heap1.clt == heap2.clt) {
+      if (heap2.clt == 0.0)  {
+	if (heap1.cld < heap2.cld)
+	  return TRUE;
+      } else if (heap2.clt > 0.0) {
+	if (heap1.cln > heap2.cln)
+	  return TRUE;
+      }
+    } 
+  } else if ((heap2.clt == heap1.clt) &&
+	     (heap2.cld == heap1.cld) &&
+	     (heap2.cln == heap1.cln) &&
+	     (heap2.deadline == heap1.deadline)) {
+    if ((heap2.oln - heap2.wlate) < (heap1.oln - heap1.wlate))
+      return TRUE;
+    else if ((heap2.oln - heap2.wlate) == (heap1.oln - heap1.wlate) &&
+	     (heap2.arr_time < heap1.arr_time))
+      return TRUE;
+  }
+
+  return FALSE;
+
+}
+
+
+/* Reorder heap. */
+void HHeapify2(struct lt_heap heap[], int i, int size) {
+
+  int l, r;
+  int smallest;
+  struct lt_heap tmp_heap;
+
+  l = HLeft(i);
+  r = HRight(i);
+ 
+  if ((l <= size) && (HCompare(heap[i-1],heap[l-1]) == TRUE))
+     smallest = l;
+  else
+    smallest = i;
+  
+  if ((r <= size) && (HCompare(heap[smallest-1],heap[r-1]) == TRUE))
+    smallest = r;
+
+  if (smallest != i) {
+    tmp_heap = heap[i-1];
+    heap[i-1] = heap[smallest-1];
+    heap[smallest-1] = tmp_heap;     
+    HHeapify2(heap, smallest, size);
+  }
+}
+
+/* Insert element into heap. */
+void HInsert2(struct lt_heap heap[], struct lt_heap tmp_heap, int size) {
+  
+  int i = size;
+
+  while (i > 1) {
+
+    if (HCompare(heap[HParent(i)-1], tmp_heap)) {
+          heap[i-1] = heap[HParent(i)-1];
+          i = HParent(i);
+    }
+    else
+      break;
+  }  
+  heap[i-1] = tmp_heap;
+}
+
+/* Remove first element and reorder heap. */
+void HExtractMin2(struct lt_heap heap[], int size) {
+
+  heap[0] = heap[size];
+  heap[size].clt = 0.0;   
+  heap[size].stream = 0; 
+  heap[size].deadline = 0; 
+  heap[size].cln = 0; 
+  heap[size].cld = 0; 
+  heap[size].oln = 0; 
+  heap[size].arr_time = 0; 
+  heap[size].wlate = 0; 
+  HHeapify2(heap, 1, size);  
+}
+
+/* Remove element from heap. */
+void HDelete2(struct lt_heap heap[], int stream, int size) {
+
+  int i=1;
+
+  while ((i < size+1) && (heap[i-1].stream != stream)) 
+    i++;
+  if (heap[i-1].stream == stream) {  
+    heap[i-1] = heap[size];   
+    heap[size].clt = 0.0;   
+    heap[size].stream = 0; 
+    heap[size].deadline = 0; 
+    heap[size].cln = 0; 
+    heap[size].cld = 0; 
+    heap[size].oln = 0; 
+    heap[size].arr_time = 0; 
+    heap[size].wlate = 0; 
+    HHeapify2(heap, i, size); 
+  } 
+}
+
+/* Reorder heap. */
+void HHeapify3(struct sl_heap heap[], int i, int size) {
+
+  int l, r;
+  int smallest;
+  struct sl_heap tmp;
+
+  l = HLeft(i);
+  r = HRight(i);
+ 
+  if ((l <= size) && (heap[l-1].readytime < heap[i-1].readytime))
+    smallest = l;
+  else
+    smallest = i;
+  
+  if ((r <= size) && (heap[r-1].readytime < heap[smallest-1].readytime))
+    smallest = r;
+
+  if (smallest != i) {
+    tmp = heap[i-1];
+    heap[i-1] = heap[smallest-1];
+    heap[smallest-1] = tmp;     
+    HHeapify3(heap, smallest, size);
+  }
+}
+
+/* Insert element into heap. */
+void HInsert3(struct sl_heap heap[], int stream, int value, int size) {
+  
+  int i = size;
+
+  while ((i > 1) && (heap[HParent(i)-1].readytime > value)) {
+    heap[i-1] = heap[HParent(i)-1];
+    i = HParent(i);
+  }  
+  heap[i-1].readytime = value;
+  heap[i-1].stream = stream;
+}
+
+/* Remove first element and reorders heap. */
+void HExtractMin3(struct sl_heap heap[], int size) {
+
+  heap[0] = heap[size];   
+  heap[size].readytime = 0;   
+  heap[size].stream = 0; 
+  HHeapify3(heap, 1, size);  
+}
+
+/* Remove element from heap. */
+void HDelete3(struct sl_heap heap[], int stream, int size) {
+
+  int i=1;
+
+  while ((i < size+1) && (heap[i-1].stream != stream)) 
+    i++;
+  if (heap[i-1].stream == stream) {  
+    heap[i-1] = heap[size];   
+    heap[size].readytime = 0;   
+    heap[size].stream = 0; 
+    HHeapify3(heap, i, size); 
+  } 
+}
diff -Naur test-for-latech/net/sched/Makefile testqf-for-latech/net/sched/Makefile
--- test-for-latech/net/sched/Makefile	2004-06-11 07:40:56.000000000 -0400
+++ testqf-for-latech/net/sched/Makefile	2004-06-11 07:48:00.000000000 -0400
@@ -30,5 +30,7 @@
 obj-$(CONFIG_NET_CLS_RSVP6)	+= cls_rsvp6.o
 obj-$(CONFIG_NET_CLS_ROUTE4)	+= cls_route.o
 obj-$(CONFIG_NET_CLS_FW)	+= cls_fw.o
+obj-$(CONFIG_NET_CLS_SOCKET)	+= cls_socket.o
+obj-$(CONFIG_NET_SCH_DWCS)	+= sch_dwcs.o
 
 include $(TOPDIR)/Rules.make
diff -Naur test-for-latech/net/sched/sch_api.c testqf-for-latech/net/sched/sch_api.c
--- test-for-latech/net/sched/sch_api.c	2004-06-11 07:40:56.000000000 -0400
+++ testqf-for-latech/net/sched/sch_api.c	2004-06-11 07:48:00.000000000 -0400
@@ -200,6 +200,21 @@
 	return NULL;
 }
 
+struct Qdisc_ops *qdisc_lookup_ops_string(char *kind)
+{
+	struct Qdisc_ops *q = NULL;
+
+	if (kind) {
+		read_lock(&qdisc_mod_lock);
+		for (q = qdisc_base; q; q = q->next) {
+			if (strcmp(kind, q->id) == 0)
+				break;
+		}
+		read_unlock(&qdisc_mod_lock);
+	}
+	return q;
+}
+
 struct Qdisc *qdisc_leaf(struct Qdisc *p, u32 classid)
 {
 	unsigned long cl;
@@ -1202,6 +1217,10 @@
 	INIT_QDISC(pfifo);
 	INIT_QDISC(bfifo);
 
+#ifdef CONFIG_NET_SCH_DWCS
+	INIT_QDISC(dwcs);
+#endif
+
 #ifdef CONFIG_NET_SCH_CBQ
 	INIT_QDISC(cbq);
 #endif
